searchNodes=[{"doc":"Provides commands for manipulating the Favicon of Phoenix Live View applications while minimizing data over the wire. The available command actions support a variety of utility operations useful for Favicon manipulation. Such as setting or removing tag attributes and adding or removing CSS classes for vector (SVG) favicons. The elements selected for manipulation are found by Javascript client code document.querySelectorAll(&quot;link[rel*=icon]&quot;) .","ref":"Phx.Live.Favicon.html","title":"Phx.Live.Favicon","type":"module"},{"doc":"Add a class_name to the list of classes on all favicon link elements","ref":"Phx.Live.Favicon.html#add_class/2","title":"Phx.Live.Favicon.add_class/2","type":"function"},{"doc":"Remove an attribute from all favicon link elements","ref":"Phx.Live.Favicon.html#remove_attr/3","title":"Phx.Live.Favicon.remove_attr/3","type":"function"},{"doc":"Remove a class_name from the list of classes on all favicon link elements","ref":"Phx.Live.Favicon.html#remove_class/2","title":"Phx.Live.Favicon.remove_class/2","type":"function"},{"doc":"Reset all favicon link elements to their initial values","ref":"Phx.Live.Favicon.html#reset/1","title":"Phx.Live.Favicon.reset/1","type":"function"},{"doc":"Reset an attribute to it's initial value on all favicon link elements","ref":"Phx.Live.Favicon.html#reset_attr/2","title":"Phx.Live.Favicon.reset_attr/2","type":"function"},{"doc":"Set a new value to the attribute on all favicon link elements","ref":"Phx.Live.Favicon.html#set_attr/3","title":"Phx.Live.Favicon.set_attr/3","type":"function"},{"doc":"Set the class on all favicon link elements","ref":"Phx.Live.Favicon.html#set_class/2","title":"Phx.Live.Favicon.set_class/2","type":"function"},{"doc":"Set the value of the {dynamic} part of the attribute to variant on all favicon link elements Dynamic attributes To define a dynamic attribute, the element in the template must have a data-dynamic-[attr] attribute with a value containing the placeholder notation {dynamic} . Example &lt;link rel='icon' href=&quot;default_fav.png&quot; data-dynamic-href=&quot;favs/{dynamic}/fav-16x16.png&quot;&gt; When an event is pushed with set_dynamic(:href, &quot;new_message&quot;) the result wil look like: &lt;link rel='icon' href=&quot;favs/new_message/fav-16x16.png&quot;&gt;","ref":"Phx.Live.Favicon.html#set_dynamic/3","title":"Phx.Live.Favicon.set_dynamic/3","type":"function"},{"doc":"Toggle class_name on all favicon link elements","ref":"Phx.Live.Favicon.html#toggle_class/2","title":"Phx.Live.Favicon.toggle_class/2","type":"function"},{"doc":"","ref":"Phx.Live.Favicon.html#t:attr/0","title":"Phx.Live.Favicon.attr/0","type":"type"},{"doc":"","ref":"Phx.Live.Favicon.html#t:class_name/0","title":"Phx.Live.Favicon.class_name/0","type":"type"},{"doc":"","ref":"Phx.Live.Favicon.html#t:value/0","title":"Phx.Live.Favicon.value/0","type":"type"},{"doc":"","ref":"Phx.Live.Favicon.html#t:variant/0","title":"Phx.Live.Favicon.variant/0","type":"type"},{"doc":"Provides commands for manipulating the Favicon of Phoenix Live View applications while minimizing data over the wire. The available command actions support a variety of utility operations useful for Favicon manipulation. Such as setting or removing tag attributes and adding or removing CSS classes for vector (SVG) favicons. A special feature is the use of the {dynamic} tag in values. This saves data over the wire by only sending a part of the value.","ref":"readme.html","title":"Phoenix Live Favicon","type":"extras"},{"doc":"Te package can be installed by adding phoenix_live_favicon to your list of dependencies in mix.exs : def deps do [ { :phoenix_live_favicon , &quot;~&gt; 0.1.0&quot; } ] end To include the necessary client side Javascript, import the Javascript module from dependency Phoenix Live Head in assets/js/app.js import &quot;phoenix_html&quot; // Establish Phoenix Socket and LiveView configuration. import { Socket } from &quot;phoenix&quot; import { LiveSocket } from &quot;../vendor/phoenix_live_view/&quot; import topbar from &quot;../vendor/topbar&quot; import &quot;phoenix_live_head&quot; // &lt;-- ADD HERE.","ref":"readme.html#installation","title":"Phoenix Live Favicon - Installation","type":"extras"},{"doc":"Add one or multiple sizes of your favicon to your applications main template. It's attributes can be manipulated using the convenience functions from the Phx.Live.Favicon module Example &lt;!-- in /templates/layout/root.html.heex --&gt; &lt;!-- some attributes have been omitted to fit box width --&gt; &lt;link [...] data-dynamic-href=&quot;images/{dynamic}/favicon-32x32.png&quot; href={&quot;images/favicon-32x32.png&quot;}&gt; &lt;link [...] data-dynamic-href=&quot;images/{dynamic}/favicon-16x16.png&quot; href={&quot;images/favicon-16x16.png&quot;}&gt; In this example the page shows images/favicon-32x32.png by default. When the user opens a chat, we want to show an favicon with an envelope. Action: Favicon.set_dynamic(socket, 'href', 'no_messages_unread') Result: The href will become images/no_messages_unread/favicon-32x32.png . When we send the user a message, the favicon should indicate a message is received. Action: Favicon.set_dynamic(socket, 'href', 'messages_unread') Result: The href becomes images/messages_unread/favicon-32x32.png . To return the favicon to it's default after the chat is closed simply call Favicon.reset(socket) . For all functions have a look at the documentation at HexDocs","ref":"readme.html#usage","title":"Phoenix Live Favicon - Usage","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial commit","ref":"changelog.html#v0-0-1","title":"Changelog - v0.0.1","type":"extras"},{"doc":"Please take a moment to review this document in order to make the contribution process easy and effective for everyone involved!","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Use the issues tracker for: Bug reports Submitting pull requests Please do not use the issue tracker for personal support requests nor feature requests. Feature and support requests should be created on the Elixir forum and be tagged with at least phoenix_live_head Support Request Feature Request We do our best to keep the issue tracker tidy and organized, making it useful for everyone. For example, we classify open issues per perceived difficulty, making it easier for developers to contribute to Phoenix Live Favicon .","ref":"contributing.html#using-the-issue-tracker","title":"Contributing - Using the issue tracker","type":"extras"},{"doc":"A bug is either a demonstrable problem that is caused by the code in the repository, or indicate missing, unclear, or misleading documentation. Good bug reports are extremely helpful - thank you! Guidelines for bug reports: Use the GitHub issue search &amp;mdash; check if the issue has already been reported. Check if the issue has been fixed &amp;mdash; try to reproduce it using the master branch in the repository. Isolate and report the problem &amp;mdash; ideally create a reduced test case. Please try to be as detailed as possible in your report. Include information about your Erlang, Elixir, Phoenix and Phoenix LiveView versions. Please provide steps to reproduce the issue as well as the outcome you were expecting! All these details will help developers to fix any potential bugs. Example: Short and descriptive example bug report title A summary of the issue and the environment in which it occurs. If suitable, include the steps required to reproduce the bug. This is the first step This is the second step Further steps, etc. &lt;url&gt; - a link to the reduced test case (e.g. a GitHub Gist) Any other information you want to share that is relevant to the issue being reported. This might include the lines of code that you have identified as causing the bug, and potential solutions (and your opinions on their merits).","ref":"contributing.html#bug-reports","title":"Contributing - Bug reports","type":"extras"},{"doc":"Feature requests are welcome and should be discussed on the Phoenix Live favicon topic on the Elixir forum . But take a moment to find out whether your idea fits with the scope and aims of the project. It's up to you to make a strong case to convince the community of the merits of this feature. Please provide as much detail and context as possible.","ref":"contributing.html#feature-requests","title":"Contributing - Feature requests","type":"extras"},{"doc":"Good pull requests - patches, improvements, new features - are a fantastic help. They should remain focused in scope and avoid containing unrelated commits. IMPORTANT : By submitting a patch, you agree that your work will be licensed under the license used by the project. If you have any large pull request in mind (e.g. implementing features, refactoring code, etc), please ask first otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project. Please adhere to the coding conventions in the project (indentation, accurate comments, etc.) and don't forget to add your own tests and documentation. When working with git, we recommend the following process in order to craft an excellent pull request: Fork the project, clone your fork, and configure the remotes: # Clone your fork of the repo into the current directory git clone https://github.com/&lt;your-username&gt;/phoenix_live_favicon # Navigate to the newly cloned directory cd phoenix # Assign the original repo to a remote called &quot;upstream&quot; git remote add upstream https://github.com/BartOtten/phoenix_live_favicon If you cloned a while ago, get the latest changes from upstream, and update your fork: git checkout master git pull upstream master git push Create a new topic branch (off of master ) to contain your feature, change, or fix. IMPORTANT : Making changes in master is discouraged. You should always keep your local master in sync with upstream master and make your changes in topic branches. git checkout -b &lt;topic-branch-name&gt; Commit your changes in logical chunks. Keep your commit messages organized, with a short description in the first line and more detailed information on the following lines. Feel free to use Git's interactive rebase feature to tidy up your commits before making them public. Make sure all the tests are still passing. mix test Push your topic branch up to your fork: git push origin &lt;topic-branch-name&gt; Open a Pull Request with a clear title and description. If you haven't updated your pull request for a while, you should consider rebasing on master and resolving any conflicts. IMPORTANT : Never ever merge upstream master into your branches. You should always git rebase on master to bring your changes up to date when necessary. git checkout master git pull upstream master git checkout &lt;your-topic-branch&gt; git rebase master Thank you for your contributions!","ref":"contributing.html#pull-requests","title":"Contributing - Pull requests","type":"extras"},{"doc":"These Guides aim to be inclusive. We use &quot;we&quot; and &quot;our&quot; instead of &quot;you&quot; and &quot;your&quot; to foster this sense of inclusion. Ideally there is something for everybody in each guide, from beginner to expert. This is hard, maybe impossible. When we need to compromise, we do so on behalf of beginning users because expert users have more tools at their disposal to help themselves. The general pattern we use for presenting information is to first introduce a small, discrete topic, then write a small amount of code to demonstrate the concept, then verify that the code worked. In this way, we build from small, easily digestible concepts into more complex ones. The shorter this cycle is, as long as the information is still clear and complete, the better. For formatting the guides: We use the &quot;elixir&quot; code fence for all module code. We use the &quot;console&quot; code fence for iex and shell commands. We use the &quot;html&quot; code fence for html templates, even if there is elixir code in the template. We use backticks for filenames and directory paths. We use backticks for module names, function names, and variable names.","ref":"contributing.html#guides","title":"Contributing - Guides","type":"extras"},{"doc":"Copyright (c) 2022 Bart Otten Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"}]